Attribute VB_Name = "File_Io"
'**********************************************************
'*** Standard module with procedures for working with   ***
'*** files. Part of the RodRego application.            ***
'**********************************************************
'***     Programmer : Nikolai Shvertner                 ***
'***     Date       : 6/20/2001                         ***
'***     Compiler   : Visual Basic 5                    ***
'***     Notes      :                                   ***
'***     Revisions  :                                   ***
'**********************************************************
Option Explicit

Sub FileOpenProc()
    Dim intRetVal
    Dim intResponse As Integer
    Dim strOpenFileName As String
    
    ' If the file has changed, save it
    If Dirty = True Then
    
        Dim strMsg As String
        Dim strFilename As String

        ' Check to see if the text has been changed.
      If Dirty Then
        strFilename = Right(frmMain.Caption, Len(frmMain.Caption) - 10)
        strMsg = "The text in [" & strFilename & "] has changed."
        strMsg = strMsg & vbCrLf
        strMsg = strMsg & "Do you want to save the changes?"
        intResponse = MsgBox(strMsg, 51, frmMain.Caption)
        Select Case intResponse
            Case 6      ' User chose Yes.
                If Left(frmMain.Caption, 8) = "Untitled" Then
                    ' The file hasn't been saved yet.
                    strFilename = "untitled.rgo"
                    ' Get the strFilename, and then call the save procedure, GetstrFilename.
                    strFilename = GetFileName(strFilename)
                Else
                    ' The form's Caption contains the name of the open file.
                    strFilename = frmMain.Caption
                End If
                ' Call the save procedure. If strFilename = Empty, then
                ' the user chose Cancel in the Save As dialog box; otherwise,
                ' save the file.
                If strFilename <> "" Then
                    SaveFileAs strFilename
                End If
            Case 7      ' User chose No. Unload the file.
                'Cancel = False
            Case 2      ' User chose Cancel. Cancel the unload.
                Exit Sub
        End Select
      End If
    End If
    On Error Resume Next
    
    frmMain.CMDialog1.Filename = ""
    frmMain.CMDialog1.ShowOpen
    If err <> 32755 Then    ' User chose Cancel.
        strOpenFileName = frmMain.CMDialog1.Filename
        ' If the file is larger than 65K, it can't
        ' be opened, so cancel the operation.
        If FileLen(strOpenFileName) > 65000 Then
            MsgBox "The file is too large to open."
            Exit Sub
        End If
        
        OpenFile (strOpenFileName)
    End If
End Sub

Function GetFileName(Filename As Variant)
    ' Display a Save As dialog box and return a filename.
    ' If the user chooses Cancel, return an empty string.
    On Error Resume Next
    frmMain.CMDialog1.Filename = Filename
    frmMain.CMDialog1.ShowSave
    If err <> 32755 Then    ' User chose Cancel.
        GetFileName = frmMain.CMDialog1.Filename
    Else
        GetFileName = ""
    End If
End Function

Sub OpenFile(Filename)
    Dim fIndex As Integer
    
    On Error Resume Next
    ' Open the selected file.
    Open Filename For Input As #1
    If err Then
        MsgBox "Can't open file: " + Filename
        Exit Sub
    End If
    ' Change the mouse pointer to an hourglass.
    Screen.MousePointer = 11
    
    ' Change the form's caption and display the new text.
    frmMain.Caption = "RodRego - " & UCase(Filename)
    frmMain.txtProg.Text = Input(LOF(1), 1)
    Dirty = False
    Close #1
    ' Reset the mouse pointer.
    Screen.MousePointer = 0
End Sub

Sub SaveFileAs(Filename)
    On Error Resume Next
    Dim strContents As String

    ' Open the file.
    Open Filename For Output As #1
    ' Place the contents of the notepad into a variable.
    strContents = frmMain.txtProg.Text
    ' Display the hourglass mouse pointer.
    Screen.MousePointer = 11
    ' Write the variable contents to a saved file.
    Print #1, strContents
    Close #1
    ' Reset the mouse pointer.
    Screen.MousePointer = 0
    ' Set the form's caption.
    If err Then
        MsgBox error, 48, App.Title
    Else
        frmMain.Caption = "RodRego - " & Filename
        ' Reset the dirty flag.
        Dirty = False
    End If
End Sub
