Attribute VB_Name = "Interpreter"
'**********************************************************
'***    Standard module with the interpreter engine.    ***
'***        Part of the RodRego application.            ***
'**********************************************************
'***     Programmer : Nikolai Shvertner                 ***
'***     Date       : 6/20/2001                         ***
'***     Compiler   : Visual Basic 5                    ***
'***     Notes      :                                   ***
'***     Revisions  : 9/20/2001                         ***
'**********************************************************
Option Explicit

Global pc As Integer      ' Program Counter
Global running As Boolean ' Flagged when the interpreter is
                          ' running in auto-step mode

Sub Step_Program()
   ' Main interpreter switch

   ' Select the corresponding program line on the LCD display
   select_line (pc)
    
   ' Check the operator
   Select Case Program(pc).OpCode
   
        Case OPCODE_END ' END operator - end the execution of the program
            Play_Sound (SND_FINISH)
            frmMain.Timer.Interval = 0
            running = False
            pc = 1
            btnStep_Enabled = False
            frmMain.Status.SimpleText = ""
            
        Case OPCODE_INC ' INC operator - increment a register
            Play_Sound (SND_INCREMENT)
            frmMain.btnInc_Click (Program(pc).Register)
            pc = Program(pc).Line1
            
        Case OPCODE_DEB  ' DEB operator - decrement a register and branch
            If Register(Program(pc).Register) > 0 Then
                Play_Sound (SND_DECREMENT)
                frmMain.btnDec_Click (Program(pc).Register)
                pc = Program(pc).Line1
            Else
                Play_Sound (SND_DECREMENT2)
                pc = Program(pc).Line2
            End If
            
    End Select
End Sub
